//--------------------------------------------------------------------------------------------------
//
// Title       : PCupdate
// Design      : mips2000
// Author      : Steven
// Company     : UW CSE
//
//-------------------------------------------------------------------------------------------------
//
// File        : PCupdate.v
// Generated   : Sat Dec  3 20:43:28 2005
// From        : interface description file
// By          : Itf2Vhdl ver. 1.20
//
//-------------------------------------------------------------------------------------------------
//
// Description : 
//
//-------------------------------------------------------------------------------------------------
`timescale 1 ns / 1 ps

//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {PCupdate}}
module PCupdate ( Reg, Next ,Inst ,PC, PCSel );

input wire [31:0] Reg, Next;
input wire [25:0] Inst;
input [1:0] PCSel ;
wire [1:0] PCSel ;

output wire [31:0] PC;

reg [31:0] src;
// Aliases
wire [31:0] offset;
wire [15:0] immediate; 
wire [25:0] jump_target;


wire [31:0] Branch;
wire [31:0] Jump;

// BEQ (and others) set PC to a value relative to the next PC. To allow
// for loops, need ability for a negative offset, so sign extend the
// offset provided as bits 15:0 of the instruction
  
assign offset = {{16{Inst[15]}},Inst}; // sign extend the immediate
assign Branch = Next + offset;
assign Jump = {Next[31:26],Inst[25:0]}; // used by J instruction
  
  // There are 4 possible sources for PC
  // 0.  PC = Next		  (Move to next Instruction)
  // 1.  PC = Next + offset (Conditional Branch)
  // 2.  PC = Reg             (Jump to Register value)
  // 3.  PC = Next[31:26],jump_target( J instruction)
  
assign PC = (PCSel[1])? ((PCSel[0])? Jump : Reg): ((PCSel[0])?	Branch : Next);

endmodule
